diff --git a/src/backend/utils/cache/lsyscache.c b/src/backend/utils/cache/lsyscache.c
index 1b7e11b93e..e189e5e564 100644
--- a/src/backend/utils/cache/lsyscache.c
+++ b/src/backend/utils/cache/lsyscache.c
@@ -3572,7 +3572,7 @@ get_index_isclustered(Oid index_oid)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for index %u", index_oid);
 
-	rd_index = (Form_pg_index) GETSTRUCT(tuple);
+	rd_index = GETSTRUCT(pg_index, tuple);
 	isclustered = rd_index->indisclustered;
 	ReleaseSysCache(tuple);
 
diff --git a/src/backend/utils/cache/partcache.c b/src/backend/utils/cache/partcache.c
index afa99c5d03..4f8c7c5bde 100644
--- a/src/backend/utils/cache/partcache.c
+++ b/src/backend/utils/cache/partcache.c
@@ -111,7 +111,7 @@ RelationBuildPartitionKey(Relation relation)
 												sizeof(PartitionKeyData));
 
 	/* Fixed-length attributes */
-	form = (Form_pg_partitioned_table) GETSTRUCT(tuple);
+	form = GETSTRUCT(pg_partitioned_table, tuple);
 	key->strategy = form->partstrat;
 	key->partnatts = form->partnatts;
 
@@ -200,7 +200,7 @@ RelationBuildPartitionKey(Relation relation)
 		if (!HeapTupleIsValid(opclasstup))
 			elog(ERROR, "cache lookup failed for opclass %u", opclass->values[i]);
 
-		opclassform = (Form_pg_opclass) GETSTRUCT(opclasstup);
+		opclassform = GETSTRUCT(pg_opclass, opclasstup);
 		key->partopfamily[i] = opclassform->opcfamily;
 		key->partopcintype[i] = opclassform->opcintype;
 
diff --git a/src/backend/utils/cache/relcache.c b/src/backend/utils/cache/relcache.c
index bdb771d278..7187de3a4c 100644
--- a/src/backend/utils/cache/relcache.c
+++ b/src/backend/utils/cache/relcache.c
@@ -572,7 +572,7 @@ RelationBuildTupleDesc(Relation relation)
 		Form_pg_attribute attp;
 		int			attnum;
 
-		attp = (Form_pg_attribute) GETSTRUCT(pg_attribute_tuple);
+		attp = GETSTRUCT(pg_attribute, pg_attribute_tuple);
 
 		attnum = attp->attnum;
 		if (attnum <= 0 || attnum > RelationGetNumberOfAttributes(relation))
@@ -785,7 +785,7 @@ RelationBuildRuleLock(Relation relation)
 
 	while (HeapTupleIsValid(rewrite_tuple = systable_getnext(rewrite_scan)))
 	{
-		Form_pg_rewrite rewrite_form = (Form_pg_rewrite) GETSTRUCT(rewrite_tuple);
+		Form_pg_rewrite rewrite_form = GETSTRUCT(pg_rewrite, rewrite_tuple);
 		bool		isnull;
 		Datum		rule_datum;
 		char	   *rule_str;
@@ -1111,7 +1111,7 @@ retry:
 	/*
 	 * get information from the pg_class_tuple
 	 */
-	relp = (Form_pg_class) GETSTRUCT(pg_class_tuple);
+	relp = GETSTRUCT(pg_class, pg_class_tuple);
 	relid = relp->oid;
 	Assert(relid == targetRelId);
 
@@ -1349,7 +1349,7 @@ RelationInitPhysicalAddr(Relation relation)
 			if (!HeapTupleIsValid(phys_tuple))
 				elog(ERROR, "could not find pg_class entry for %u",
 					 RelationGetRelid(relation));
-			physrel = (Form_pg_class) GETSTRUCT(phys_tuple);
+			physrel = GETSTRUCT(pg_class, phys_tuple);
 
 			relation->rd_rel->reltablespace = physrel->reltablespace;
 			relation->rd_rel->relfilenode = physrel->relfilenode;
@@ -1442,7 +1442,7 @@ RelationInitIndexAccessInfo(Relation relation)
 			 RelationGetRelid(relation));
 	oldcontext = MemoryContextSwitchTo(CacheMemoryContext);
 	relation->rd_indextuple = heap_copytuple(tuple);
-	relation->rd_index = (Form_pg_index) GETSTRUCT(relation->rd_indextuple);
+	relation->rd_index = GETSTRUCT(pg_index, relation->rd_indextuple);
 	MemoryContextSwitchTo(oldcontext);
 	ReleaseSysCache(tuple);
 
@@ -1454,7 +1454,7 @@ RelationInitIndexAccessInfo(Relation relation)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for access method %u",
 			 relation->rd_rel->relam);
-	aform = (Form_pg_am) GETSTRUCT(tuple);
+	aform = GETSTRUCT(pg_am, tuple);
 	relation->rd_amhandler = aform->amhandler;
 	ReleaseSysCache(tuple);
 
@@ -1728,7 +1728,7 @@ LookupOpclassInfo(Oid operatorClassOid,
 
 	if (HeapTupleIsValid(htup = systable_getnext(scan)))
 	{
-		Form_pg_opclass opclassform = (Form_pg_opclass) GETSTRUCT(htup);
+		Form_pg_opclass opclassform = GETSTRUCT(pg_opclass, htup);
 
 		opcentry->opcfamily = opclassform->opcfamily;
 		opcentry->opcintype = opclassform->opcintype;
@@ -1763,7 +1763,7 @@ LookupOpclassInfo(Oid operatorClassOid,
 
 		while (HeapTupleIsValid(htup = systable_getnext(scan)))
 		{
-			Form_pg_amproc amprocform = (Form_pg_amproc) GETSTRUCT(htup);
+			Form_pg_amproc amprocform = GETSTRUCT(pg_amproc, htup);
 
 			if (amprocform->amprocnum <= 0 ||
 				(StrategyNumber) amprocform->amprocnum > numSupport)
@@ -1832,7 +1832,7 @@ RelationInitTableAccessMethod(Relation relation)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for access method %u",
 				 relation->rd_rel->relam);
-		aform = (Form_pg_am) GETSTRUCT(tuple);
+		aform = GETSTRUCT(pg_am, tuple);
 		relation->rd_amhandler = aform->amhandler;
 		ReleaseSysCache(tuple);
 	}
@@ -2257,7 +2257,7 @@ RelationReloadIndexInfo(Relation relation)
 	if (!HeapTupleIsValid(pg_class_tuple))
 		elog(ERROR, "could not find pg_class tuple for index %u",
 			 RelationGetRelid(relation));
-	relp = (Form_pg_class) GETSTRUCT(pg_class_tuple);
+	relp = GETSTRUCT(pg_class, pg_class_tuple);
 	memcpy(relation->rd_rel, relp, CLASS_TUPLE_SIZE);
 	/* Reload reloptions in case they changed */
 	if (relation->rd_options)
@@ -2286,7 +2286,7 @@ RelationReloadIndexInfo(Relation relation)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for index %u",
 				 RelationGetRelid(relation));
-		index = (Form_pg_index) GETSTRUCT(tuple);
+		index = GETSTRUCT(pg_index, tuple);
 
 		/*
 		 * Basically, let's just copy all the bool fields.  There are one or
@@ -2378,7 +2378,7 @@ RelationReloadNailed(Relation relation)
 
 			pg_class_tuple = ScanPgRelation(RelationGetRelid(relation),
 											true, false);
-			relp = (Form_pg_class) GETSTRUCT(pg_class_tuple);
+			relp = GETSTRUCT(pg_class, pg_class_tuple);
 			memcpy(relation->rd_rel, relp, CLASS_TUPLE_SIZE);
 			heap_freetuple(pg_class_tuple);
 
@@ -3721,7 +3721,7 @@ RelationSetNewRelfilenumber(Relation relation, char persistence)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "could not find tuple for relation %u",
 			 RelationGetRelid(relation));
-	classform = (Form_pg_class) GETSTRUCT(tuple);
+	classform = GETSTRUCT(pg_class, tuple);
 
 	/*
 	 * Schedule unlinking of the old storage at transaction commit.
@@ -4137,7 +4137,7 @@ RelationCacheInitializePhase3(void)
 			if (!HeapTupleIsValid(htup))
 				elog(FATAL, "cache lookup failed for relation %u",
 					 RelationGetRelid(relation));
-			relp = (Form_pg_class) GETSTRUCT(htup);
+			relp = GETSTRUCT(pg_class, htup);
 
 			/*
 			 * Copy tuple to relation->rd_rel. (See notes in
@@ -4382,7 +4382,7 @@ AttrDefaultFetch(Relation relation, int ndef)
 
 	while (HeapTupleIsValid(htup = systable_getnext(adscan)))
 	{
-		Form_pg_attrdef adform = (Form_pg_attrdef) GETSTRUCT(htup);
+		Form_pg_attrdef adform = GETSTRUCT(pg_attrdef, htup);
 		Datum		val;
 		bool		isnull;
 
@@ -4478,7 +4478,7 @@ CheckConstraintFetch(Relation relation)
 
 	while (HeapTupleIsValid(htup = systable_getnext(conscan)))
 	{
-		Form_pg_constraint conform = (Form_pg_constraint) GETSTRUCT(htup);
+		Form_pg_constraint conform = GETSTRUCT(pg_constraint, htup);
 		Datum		val;
 		bool		isnull;
 
@@ -4602,7 +4602,7 @@ RelationGetFKeyList(Relation relation)
 
 	while (HeapTupleIsValid(htup = systable_getnext(conscan)))
 	{
-		Form_pg_constraint constraint = (Form_pg_constraint) GETSTRUCT(htup);
+		Form_pg_constraint constraint = GETSTRUCT(pg_constraint, htup);
 		ForeignKeyCacheInfo *info;
 
 		/* consider only foreign keys */
@@ -4709,7 +4709,7 @@ RelationGetIndexList(Relation relation)
 
 	while (HeapTupleIsValid(htup = systable_getnext(indscan)))
 	{
-		Form_pg_index index = (Form_pg_index) GETSTRUCT(htup);
+		Form_pg_index index = GETSTRUCT(pg_index, htup);
 
 		/*
 		 * Ignore any indexes that are currently being dropped.  This will
@@ -4828,7 +4828,7 @@ RelationGetStatExtList(Relation relation)
 
 	while (HeapTupleIsValid(htup = systable_getnext(indscan)))
 	{
-		Oid			oid = ((Form_pg_statistic_ext) GETSTRUCT(htup))->oid;
+		Oid			oid = (GETSTRUCT(pg_statistic_ext, htup))->oid;
 
 		result = lappend_oid(result, oid);
 	}
@@ -5474,7 +5474,7 @@ RelationGetExclusionInfo(Relation indexRelation,
 
 	while (HeapTupleIsValid(htup = systable_getnext(conscan)))
 	{
-		Form_pg_constraint conform = (Form_pg_constraint) GETSTRUCT(htup);
+		Form_pg_constraint conform = GETSTRUCT(pg_constraint, htup);
 		Datum		val;
 		bool		isnull;
 		ArrayType  *arr;
@@ -5621,7 +5621,7 @@ RelationBuildPublicationDesc(Relation relation, PublicationDesc *pubdesc)
 		if (!HeapTupleIsValid(tup))
 			elog(ERROR, "cache lookup failed for publication %u", pubid);
 
-		pubform = (Form_pg_publication) GETSTRUCT(tup);
+		pubform = GETSTRUCT(pg_publication, tup);
 
 		pubdesc->pubactions.pubinsert |= pubform->pubinsert;
 		pubdesc->pubactions.pubupdate |= pubform->pubupdate;
@@ -6088,7 +6088,7 @@ load_relcache_init_file(bool shared)
 
 			/* Fix up internal pointers in the tuple -- see heap_copytuple */
 			rel->rd_indextuple->t_data = (HeapTupleHeader) ((char *) rel->rd_indextuple + HEAPTUPLESIZE);
-			rel->rd_index = (Form_pg_index) GETSTRUCT(rel->rd_indextuple);
+			rel->rd_index = GETSTRUCT(pg_index, rel->rd_indextuple);
 
 			/*
 			 * prepare index info context --- parameters should match
diff --git a/src/backend/utils/cache/relfilenumbermap.c b/src/backend/utils/cache/relfilenumbermap.c
index c4245d5ccd..7570f5e095 100644
--- a/src/backend/utils/cache/relfilenumbermap.c
+++ b/src/backend/utils/cache/relfilenumbermap.c
@@ -209,7 +209,7 @@ RelidByRelfilenumber(Oid reltablespace, RelFileNumber relfilenumber)
 
 		while (HeapTupleIsValid(ntp = systable_getnext(scandesc)))
 		{
-			Form_pg_class classform = (Form_pg_class) GETSTRUCT(ntp);
+			Form_pg_class classform = GETSTRUCT(pg_class, ntp);
 
 			if (found)
 				elog(ERROR,
diff --git a/src/backend/utils/cache/syscache.c b/src/backend/utils/cache/syscache.c
index 1912b12146..a8c320ef91 100644
--- a/src/backend/utils/cache/syscache.c
+++ b/src/backend/utils/cache/syscache.c
@@ -1320,7 +1320,7 @@ SearchSysCacheAttName(Oid relid, const char *attname)
 							CStringGetDatum(attname));
 	if (!HeapTupleIsValid(tuple))
 		return NULL;
-	if (((Form_pg_attribute) GETSTRUCT(tuple))->attisdropped)
+	if ((GETSTRUCT(pg_attribute, tuple))->attisdropped)
 	{
 		ReleaseSysCache(tuple);
 		return NULL;
@@ -1383,7 +1383,7 @@ SearchSysCacheAttNum(Oid relid, int16 attnum)
 							Int16GetDatum(attnum));
 	if (!HeapTupleIsValid(tuple))
 		return NULL;
-	if (((Form_pg_attribute) GETSTRUCT(tuple))->attisdropped)
+	if ((GETSTRUCT(pg_attribute, tuple))->attisdropped)
 	{
 		ReleaseSysCache(tuple);
 		return NULL;
diff --git a/src/backend/utils/cache/ts_cache.c b/src/backend/utils/cache/ts_cache.c
index 24808dfbb1..e1d0dad795 100644
--- a/src/backend/utils/cache/ts_cache.c
+++ b/src/backend/utils/cache/ts_cache.c
@@ -152,7 +152,7 @@ lookup_ts_parser_cache(Oid prsId)
 		if (!HeapTupleIsValid(tp))
 			elog(ERROR, "cache lookup failed for text search parser %u",
 				 prsId);
-		prs = (Form_pg_ts_parser) GETSTRUCT(tp);
+		prs = GETSTRUCT(pg_ts_parser, tp);
 
 		/*
 		 * Sanity checks
@@ -254,7 +254,7 @@ lookup_ts_dictionary_cache(Oid dictId)
 		if (!HeapTupleIsValid(tpdict))
 			elog(ERROR, "cache lookup failed for text search dictionary %u",
 				 dictId);
-		dict = (Form_pg_ts_dict) GETSTRUCT(tpdict);
+		dict = GETSTRUCT(pg_ts_dict, tpdict);
 
 		/*
 		 * Sanity checks
@@ -270,7 +270,7 @@ lookup_ts_dictionary_cache(Oid dictId)
 		if (!HeapTupleIsValid(tptmpl))
 			elog(ERROR, "cache lookup failed for text search template %u",
 				 dict->dicttemplate);
-		template = (Form_pg_ts_template) GETSTRUCT(tptmpl);
+		template = GETSTRUCT(pg_ts_template, tptmpl);
 
 		/*
 		 * Sanity checks
@@ -424,7 +424,7 @@ lookup_ts_config_cache(Oid cfgId)
 		if (!HeapTupleIsValid(tp))
 			elog(ERROR, "cache lookup failed for text search configuration %u",
 				 cfgId);
-		cfg = (Form_pg_ts_config) GETSTRUCT(tp);
+		cfg = GETSTRUCT(pg_ts_config, tp);
 
 		/*
 		 * Sanity checks
@@ -484,7 +484,7 @@ lookup_ts_config_cache(Oid cfgId)
 
 		while ((maptup = systable_getnext_ordered(mapscan, ForwardScanDirection)) != NULL)
 		{
-			Form_pg_ts_config_map cfgmap = (Form_pg_ts_config_map) GETSTRUCT(maptup);
+			Form_pg_ts_config_map cfgmap = GETSTRUCT(pg_ts_config_map, maptup);
 			int			toktype = cfgmap->maptokentype;
 
 			if (toktype <= 0 || toktype > MAXTOKENTYPE)
@@ -625,7 +625,7 @@ check_TSCurrentConfig(char **newval, void **extra, GucSource source)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for text search configuration %u",
 				 cfgId);
-		cfg = (Form_pg_ts_config) GETSTRUCT(tuple);
+		cfg = GETSTRUCT(pg_ts_config, tuple);
 
 		buf = quote_qualified_identifier(get_namespace_name(cfg->cfgnamespace),
 										 NameStr(cfg->cfgname));
diff --git a/src/backend/utils/cache/typcache.c b/src/backend/utils/cache/typcache.c
index 808f9ebd0d..6b55c4a4e1 100644
--- a/src/backend/utils/cache/typcache.c
+++ b/src/backend/utils/cache/typcache.c
@@ -383,7 +383,7 @@ lookup_type_cache(Oid type_id, int flags)
 			ereport(ERROR,
 					(errcode(ERRCODE_UNDEFINED_OBJECT),
 					 errmsg("type with OID %u does not exist", type_id)));
-		typtup = (Form_pg_type) GETSTRUCT(tp);
+		typtup = GETSTRUCT(pg_type, tp);
 		if (!typtup->typisdefined)
 			ereport(ERROR,
 					(errcode(ERRCODE_UNDEFINED_OBJECT),
@@ -438,7 +438,7 @@ lookup_type_cache(Oid type_id, int flags)
 			ereport(ERROR,
 					(errcode(ERRCODE_UNDEFINED_OBJECT),
 					 errmsg("type with OID %u does not exist", type_id)));
-		typtup = (Form_pg_type) GETSTRUCT(tp);
+		typtup = GETSTRUCT(pg_type, tp);
 		if (!typtup->typisdefined)
 			ereport(ERROR,
 					(errcode(ERRCODE_UNDEFINED_OBJECT),
@@ -922,7 +922,7 @@ load_rangetype_info(TypeCacheEntry *typentry)
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for range type %u",
 			 typentry->type_id);
-	pg_range = (Form_pg_range) GETSTRUCT(tup);
+	pg_range = GETSTRUCT(pg_range, tup);
 
 	subtypeOid = pg_range->rngsubtype;
 	typentry->rng_collation = pg_range->rngcollation;
@@ -1032,7 +1032,7 @@ load_domaintype_info(TypeCacheEntry *typentry)
 		tup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typeOid));
 		if (!HeapTupleIsValid(tup))
 			elog(ERROR, "cache lookup failed for type %u", typeOid);
-		typTup = (Form_pg_type) GETSTRUCT(tup);
+		typTup = GETSTRUCT(pg_type, tup);
 
 		if (typTup->typtype != TYPTYPE_DOMAIN)
 		{
@@ -1056,7 +1056,7 @@ load_domaintype_info(TypeCacheEntry *typentry)
 
 		while (HeapTupleIsValid(conTup = systable_getnext(scan)))
 		{
-			Form_pg_constraint c = (Form_pg_constraint) GETSTRUCT(conTup);
+			Form_pg_constraint c = GETSTRUCT(pg_constraint, conTup);
 			Datum		val;
 			bool		isNull;
 			char	   *constring;
@@ -2592,7 +2592,7 @@ load_enum_cache_data(TypeCacheEntry *tcache)
 
 	while (HeapTupleIsValid(enum_tuple = systable_getnext(enum_scan)))
 	{
-		Form_pg_enum en = (Form_pg_enum) GETSTRUCT(enum_tuple);
+		Form_pg_enum en = GETSTRUCT(pg_enum, enum_tuple);
 
 		if (numitems >= maxitems)
 		{
diff --git a/src/backend/utils/fmgr/fmgr.c b/src/backend/utils/fmgr/fmgr.c
index a9dd068095..125a175a11 100644
--- a/src/backend/utils/fmgr/fmgr.c
+++ b/src/backend/utils/fmgr/fmgr.c
@@ -181,7 +181,7 @@ fmgr_info_cxt_security(Oid functionId, FmgrInfo *finfo, MemoryContext mcxt,
 	procedureTuple = SearchSysCache1(PROCOID, ObjectIdGetDatum(functionId));
 	if (!HeapTupleIsValid(procedureTuple))
 		elog(ERROR, "cache lookup failed for function %u", functionId);
-	procedureStruct = (Form_pg_proc) GETSTRUCT(procedureTuple);
+	procedureStruct = GETSTRUCT(pg_proc, procedureTuple);
 
 	finfo->fn_nargs = procedureStruct->pronargs;
 	finfo->fn_strict = procedureStruct->proisstrict;
@@ -291,7 +291,7 @@ fmgr_symbol(Oid functionId, char **mod, char **fn)
 	procedureTuple = SearchSysCache1(PROCOID, ObjectIdGetDatum(functionId));
 	if (!HeapTupleIsValid(procedureTuple))
 		elog(ERROR, "cache lookup failed for function %u", functionId);
-	procedureStruct = (Form_pg_proc) GETSTRUCT(procedureTuple);
+	procedureStruct = GETSTRUCT(pg_proc, procedureTuple);
 
 	if (procedureStruct->prosecdef ||
 		!heap_attisnull(procedureTuple, Anum_pg_proc_proconfig, NULL) ||
@@ -431,7 +431,7 @@ fmgr_info_C_lang(Oid functionId, FmgrInfo *finfo, HeapTuple procedureTuple)
 static void
 fmgr_info_other_lang(Oid functionId, FmgrInfo *finfo, HeapTuple procedureTuple)
 {
-	Form_pg_proc procedureStruct = (Form_pg_proc) GETSTRUCT(procedureTuple);
+	Form_pg_proc procedureStruct = GETSTRUCT(pg_proc, procedureTuple);
 	Oid			language = procedureStruct->prolang;
 	HeapTuple	languageTuple;
 	Form_pg_language languageStruct;
@@ -440,7 +440,7 @@ fmgr_info_other_lang(Oid functionId, FmgrInfo *finfo, HeapTuple procedureTuple)
 	languageTuple = SearchSysCache1(LANGOID, ObjectIdGetDatum(language));
 	if (!HeapTupleIsValid(languageTuple))
 		elog(ERROR, "cache lookup failed for language %u", language);
-	languageStruct = (Form_pg_language) GETSTRUCT(languageTuple);
+	languageStruct = GETSTRUCT(pg_language, languageTuple);
 
 	/*
 	 * Look up the language's call handler function, ignoring any attributes
@@ -528,7 +528,7 @@ fetch_finfo_record(void *filehandle, const char *funcname)
 static CFuncHashTabEntry *
 lookup_C_func(HeapTuple procedureTuple)
 {
-	Oid			fn_oid = ((Form_pg_proc) GETSTRUCT(procedureTuple))->oid;
+	Oid			fn_oid = (GETSTRUCT(pg_proc, procedureTuple))->oid;
 	CFuncHashTabEntry *entry;
 
 	if (CFuncHash == NULL)
@@ -553,7 +553,7 @@ static void
 record_C_func(HeapTuple procedureTuple,
 			  PGFunction user_fn, const Pg_finfo_record *inforec)
 {
-	Oid			fn_oid = ((Form_pg_proc) GETSTRUCT(procedureTuple))->oid;
+	Oid			fn_oid = (GETSTRUCT(pg_proc, procedureTuple))->oid;
 	CFuncHashTabEntry *entry;
 	bool		found;
 
@@ -671,7 +671,7 @@ fmgr_security_definer(PG_FUNCTION_ARGS)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for function %u",
 				 fcinfo->flinfo->fn_oid);
-		procedureStruct = (Form_pg_proc) GETSTRUCT(tuple);
+		procedureStruct = GETSTRUCT(pg_proc, tuple);
 
 		if (procedureStruct->prosecdef)
 			fcache->userid = procedureStruct->proowner;
@@ -2035,7 +2035,7 @@ CheckFunctionValidatorAccess(Oid validatorOid, Oid functionOid)
 		ereport(ERROR,
 				(errcode(ERRCODE_UNDEFINED_FUNCTION),
 				 errmsg("function with OID %u does not exist", functionOid)));
-	procStruct = (Form_pg_proc) GETSTRUCT(procTup);
+	procStruct = GETSTRUCT(pg_proc, procTup);
 
 	/*
 	 * Fetch pg_language entry to know if this is the correct validation
@@ -2044,7 +2044,7 @@ CheckFunctionValidatorAccess(Oid validatorOid, Oid functionOid)
 	langTup = SearchSysCache1(LANGOID, ObjectIdGetDatum(procStruct->prolang));
 	if (!HeapTupleIsValid(langTup))
 		elog(ERROR, "cache lookup failed for language %u", procStruct->prolang);
-	langStruct = (Form_pg_language) GETSTRUCT(langTup);
+	langStruct = GETSTRUCT(pg_language, langTup);
 
 	if (langStruct->lanvalidator != validatorOid)
 		ereport(ERROR,
diff --git a/src/backend/utils/fmgr/funcapi.c b/src/backend/utils/fmgr/funcapi.c
index a1fe50ffca..213121461d 100644
--- a/src/backend/utils/fmgr/funcapi.c
+++ b/src/backend/utils/fmgr/funcapi.c
@@ -403,7 +403,7 @@ internal_get_result_type(Oid funcid,
 	tp = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
-	procform = (Form_pg_proc) GETSTRUCT(tp);
+	procform = GETSTRUCT(pg_proc, tp);
 
 	rettype = procform->prorettype;
 
@@ -1337,7 +1337,7 @@ int
 get_func_arg_info(HeapTuple procTup,
 				  Oid **p_argtypes, char ***p_argnames, char **p_argmodes)
 {
-	Form_pg_proc procStruct = (Form_pg_proc) GETSTRUCT(procTup);
+	Form_pg_proc procStruct = GETSTRUCT(pg_proc, procTup);
 	Datum		proallargtypes;
 	Datum		proargmodes;
 	Datum		proargnames;
@@ -1667,7 +1667,7 @@ get_func_result_name(Oid functionId)
 TupleDesc
 build_function_result_tupdesc_t(HeapTuple procTuple)
 {
-	Form_pg_proc procform = (Form_pg_proc) GETSTRUCT(procTuple);
+	Form_pg_proc procform = GETSTRUCT(pg_proc, procTuple);
 	Datum		proallargtypes;
 	Datum		proargmodes;
 	Datum		proargnames;
diff --git a/src/backend/utils/init/miscinit.c b/src/backend/utils/init/miscinit.c
index eb43b2c5e5..df10da08b9 100644
--- a/src/backend/utils/init/miscinit.c
+++ b/src/backend/utils/init/miscinit.c
@@ -683,7 +683,7 @@ has_rolreplication(Oid roleid)
 	utup = SearchSysCache1(AUTHOID, ObjectIdGetDatum(roleid));
 	if (HeapTupleIsValid(utup))
 	{
-		result = ((Form_pg_authid) GETSTRUCT(utup))->rolreplication;
+		result = (GETSTRUCT(pg_authid, utup))->rolreplication;
 		ReleaseSysCache(utup);
 	}
 	return result;
@@ -732,7 +732,7 @@ InitializeSessionUserId(const char *rolename, Oid roleid)
 					 errmsg("role with OID %u does not exist", roleid)));
 	}
 
-	rform = (Form_pg_authid) GETSTRUCT(roleTup);
+	rform = GETSTRUCT(pg_authid, roleTup);
 	roleid = rform->oid;
 	rname = NameStr(rform->rolname);
 
@@ -925,7 +925,7 @@ GetUserNameFromId(Oid roleid, bool noerr)
 	}
 	else
 	{
-		result = pstrdup(NameStr(((Form_pg_authid) GETSTRUCT(tuple))->rolname));
+		result = pstrdup(NameStr((GETSTRUCT(pg_authid, tuple))->rolname));
 		ReleaseSysCache(tuple);
 	}
 	return result;
diff --git a/src/backend/utils/init/postinit.c b/src/backend/utils/init/postinit.c
index a5c208a20a..3ddd0d3c66 100644
--- a/src/backend/utils/init/postinit.c
+++ b/src/backend/utils/init/postinit.c
@@ -321,7 +321,7 @@ CheckMyDatabase(const char *name, bool am_superuser, bool override_allow_connect
 	tup = SearchSysCache1(DATABASEOID, ObjectIdGetDatum(MyDatabaseId));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for database %u", MyDatabaseId);
-	dbform = (Form_pg_database) GETSTRUCT(tup);
+	dbform = GETSTRUCT(pg_database, tup);
 
 	/* This recheck is strictly paranoia */
 	if (strcmp(name, NameStr(dbform->datname)) != 0)
@@ -921,7 +921,7 @@ InitPostgres(const char *in_dbname, Oid dboid, const char *username,
 			ereport(FATAL,
 					(errcode(ERRCODE_UNDEFINED_DATABASE),
 					 errmsg("database \"%s\" does not exist", in_dbname)));
-		dbform = (Form_pg_database) GETSTRUCT(tuple);
+		dbform = GETSTRUCT(pg_database, tuple);
 		MyDatabaseId = dbform->oid;
 		MyDatabaseTableSpace = dbform->dattablespace;
 		/* take database name from the caller, just for paranoia */
@@ -938,7 +938,7 @@ InitPostgres(const char *in_dbname, Oid dboid, const char *username,
 			ereport(FATAL,
 					(errcode(ERRCODE_UNDEFINED_DATABASE),
 					 errmsg("database %u does not exist", dboid)));
-		dbform = (Form_pg_database) GETSTRUCT(tuple);
+		dbform = GETSTRUCT(pg_database, tuple);
 		MyDatabaseId = dbform->oid;
 		MyDatabaseTableSpace = dbform->dattablespace;
 		Assert(MyDatabaseId == dboid);
@@ -1021,8 +1021,8 @@ InitPostgres(const char *in_dbname, Oid dboid, const char *username,
 
 		tuple = GetDatabaseTuple(dbname);
 		if (!HeapTupleIsValid(tuple) ||
-			MyDatabaseId != ((Form_pg_database) GETSTRUCT(tuple))->oid ||
-			MyDatabaseTableSpace != ((Form_pg_database) GETSTRUCT(tuple))->dattablespace)
+			MyDatabaseId != (GETSTRUCT(pg_database, tuple))->oid ||
+			MyDatabaseTableSpace != (GETSTRUCT(pg_database, tuple))->dattablespace)
 			ereport(FATAL,
 					(errcode(ERRCODE_UNDEFINED_DATABASE),
 					 errmsg("database \"%s\" does not exist", dbname),
diff --git a/src/backend/utils/misc/rls.c b/src/backend/utils/misc/rls.c
index d15880670f..73fd21d843 100644
--- a/src/backend/utils/misc/rls.c
+++ b/src/backend/utils/misc/rls.c
@@ -66,7 +66,7 @@ check_enable_rls(Oid relid, Oid checkAsUser, bool noError)
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		return RLS_NONE;
-	classform = (Form_pg_class) GETSTRUCT(tuple);
+	classform = GETSTRUCT(pg_class, tuple);
 
 	relrowsecurity = classform->relrowsecurity;
 	relforcerowsecurity = classform->relforcerowsecurity;
diff --git a/src/backend/utils/misc/superuser.c b/src/backend/utils/misc/superuser.c
index d20e7af797..1902f49d0a 100644
--- a/src/backend/utils/misc/superuser.c
+++ b/src/backend/utils/misc/superuser.c
@@ -70,7 +70,7 @@ superuser_arg(Oid roleid)
 	rtup = SearchSysCache1(AUTHOID, ObjectIdGetDatum(roleid));
 	if (HeapTupleIsValid(rtup))
 	{
-		result = ((Form_pg_authid) GETSTRUCT(rtup))->rolsuper;
+		result = (GETSTRUCT(pg_authid, rtup))->rolsuper;
 		ReleaseSysCache(rtup);
 	}
 	else
diff --git a/src/include/access/htup_details.h b/src/include/access/htup_details.h
index 51a60eda08..7310e3b2b8 100644
--- a/src/include/access/htup_details.h
+++ b/src/include/access/htup_details.h
@@ -651,7 +651,7 @@ struct MinimalTupleData
 /*
  * GETSTRUCT - given a HeapTuple pointer, return address of the user data
  */
-#define GETSTRUCT(TUP) ((char *) ((TUP)->t_data) + (TUP)->t_data->t_hoff)
+#define GETSTRUCT(CAT, TUP) ((Form_##CAT) ((char *) ((TUP)->t_data) + (TUP)->t_data->t_hoff))
 
 /*
  * Accessor macros to be used with HeapTuple pointers.
diff --git a/src/pl/plperl/plperl.c b/src/pl/plperl/plperl.c
index edb93ec1c4..1aa8227afb 100644
--- a/src/pl/plperl/plperl.c
+++ b/src/pl/plperl/plperl.c
@@ -1994,7 +1994,7 @@ plperl_validator(PG_FUNCTION_ARGS)
 	tuple = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcoid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for function %u", funcoid);
-	proc = (Form_pg_proc) GETSTRUCT(tuple);
+	proc = GETSTRUCT(pg_proc, tuple);
 
 	functyptype = get_typtype(proc->prorettype);
 
@@ -2717,7 +2717,7 @@ compile_plperl_function(Oid fn_oid, bool is_trigger, bool is_event_trigger)
 	procTup = SearchSysCache1(PROCOID, ObjectIdGetDatum(fn_oid));
 	if (!HeapTupleIsValid(procTup))
 		elog(ERROR, "cache lookup failed for function %u", fn_oid);
-	procStruct = (Form_pg_proc) GETSTRUCT(procTup);
+	procStruct = GETSTRUCT(pg_proc, procTup);
 
 	/*
 	 * Try to find function in plperl_proc_hash.  The reason for this
@@ -2818,7 +2818,7 @@ compile_plperl_function(Oid fn_oid, bool is_trigger, bool is_event_trigger)
 		if (!HeapTupleIsValid(langTup))
 			elog(ERROR, "cache lookup failed for language %u",
 				 procStruct->prolang);
-		langStruct = (Form_pg_language) GETSTRUCT(langTup);
+		langStruct = GETSTRUCT(pg_language, langTup);
 		prodesc->lang_oid = langStruct->oid;
 		prodesc->lanpltrusted = langStruct->lanpltrusted;
 		ReleaseSysCache(langTup);
@@ -2834,7 +2834,7 @@ compile_plperl_function(Oid fn_oid, bool is_trigger, bool is_event_trigger)
 			typeTup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(rettype));
 			if (!HeapTupleIsValid(typeTup))
 				elog(ERROR, "cache lookup failed for type %u", rettype);
-			typeStruct = (Form_pg_type) GETSTRUCT(typeTup);
+			typeStruct = GETSTRUCT(pg_type, typeTup);
 
 			/* Disallow pseudotype result, except VOID or RECORD */
 			if (typeStruct->typtype == TYPTYPE_PSEUDO)
@@ -2883,7 +2883,7 @@ compile_plperl_function(Oid fn_oid, bool is_trigger, bool is_event_trigger)
 				typeTup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(argtype));
 				if (!HeapTupleIsValid(typeTup))
 					elog(ERROR, "cache lookup failed for type %u", argtype);
-				typeStruct = (Form_pg_type) GETSTRUCT(typeTup);
+				typeStruct = GETSTRUCT(pg_type, typeTup);
 
 				/* Disallow pseudotype argument, except RECORD */
 				if (typeStruct->typtype == TYPTYPE_PSEUDO &&
diff --git a/src/pl/plpgsql/src/pl_comp.c b/src/pl/plpgsql/src/pl_comp.c
index b791c23f06..96b6f547df 100644
--- a/src/pl/plpgsql/src/pl_comp.c
+++ b/src/pl/plpgsql/src/pl_comp.c
@@ -149,7 +149,7 @@ plpgsql_compile(FunctionCallInfo fcinfo, bool forValidator)
 	procTup = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcOid));
 	if (!HeapTupleIsValid(procTup))
 		elog(ERROR, "cache lookup failed for function %u", funcOid);
-	procStruct = (Form_pg_proc) GETSTRUCT(procTup);
+	procStruct = GETSTRUCT(pg_proc, procTup);
 
 	/*
 	 * See if there's already a cache entry for the current FmgrInfo. If not,
@@ -267,7 +267,7 @@ do_compile(FunctionCallInfo fcinfo,
 		   PLpgSQL_func_hashkey *hashkey,
 		   bool forValidator)
 {
-	Form_pg_proc procStruct = (Form_pg_proc) GETSTRUCT(procTup);
+	Form_pg_proc procStruct = GETSTRUCT(pg_proc, procTup);
 	bool		is_dml_trigger = CALLED_AS_TRIGGER(fcinfo);
 	bool		is_event_trigger = CALLED_AS_EVENT_TRIGGER(fcinfo);
 	Datum		prosrcdatum;
@@ -545,7 +545,7 @@ do_compile(FunctionCallInfo fcinfo,
 			typeTup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(rettypeid));
 			if (!HeapTupleIsValid(typeTup))
 				elog(ERROR, "cache lookup failed for type %u", rettypeid);
-			typeStruct = (Form_pg_type) GETSTRUCT(typeTup);
+			typeStruct = GETSTRUCT(pg_type, typeTup);
 
 			/* Disallow pseudotype result, except VOID or RECORD */
 			/* (note we already replaced polymorphic types) */
@@ -1649,7 +1649,7 @@ plpgsql_parse_wordtype(char *ident)
 	typeTup = LookupTypeName(NULL, typeName, NULL, false);
 	if (typeTup)
 	{
-		Form_pg_type typeStruct = (Form_pg_type) GETSTRUCT(typeTup);
+		Form_pg_type typeStruct = GETSTRUCT(pg_type, typeTup);
 
 		if (!typeStruct->typisdefined ||
 			typeStruct->typrelid != InvalidOid)
@@ -1741,7 +1741,7 @@ plpgsql_parse_cwordtype(List *idents)
 	classtup = SearchSysCache1(RELOID, ObjectIdGetDatum(classOid));
 	if (!HeapTupleIsValid(classtup))
 		goto done;
-	classStruct = (Form_pg_class) GETSTRUCT(classtup);
+	classStruct = GETSTRUCT(pg_class, classtup);
 
 	/*
 	 * It must be a relation, sequence, view, materialized view, composite
@@ -1762,7 +1762,7 @@ plpgsql_parse_cwordtype(List *idents)
 	attrtup = SearchSysCacheAttName(classOid, fldname);
 	if (!HeapTupleIsValid(attrtup))
 		goto done;
-	attrStruct = (Form_pg_attribute) GETSTRUCT(attrtup);
+	attrStruct = GETSTRUCT(pg_attribute, attrtup);
 
 	typetup = SearchSysCache1(TYPEOID,
 							  ObjectIdGetDatum(attrStruct->atttypid));
@@ -2113,7 +2113,7 @@ static PLpgSQL_type *
 build_datatype(HeapTuple typeTup, int32 typmod,
 			   Oid collation, TypeName *origtypname)
 {
-	Form_pg_type typeStruct = (Form_pg_type) GETSTRUCT(typeTup);
+	Form_pg_type typeStruct = GETSTRUCT(pg_type, typeTup);
 	PLpgSQL_type *typ;
 
 	if (!typeStruct->typisdefined)
diff --git a/src/pl/plpgsql/src/pl_handler.c b/src/pl/plpgsql/src/pl_handler.c
index 190d286f1c..632e4c351d 100644
--- a/src/pl/plpgsql/src/pl_handler.c
+++ b/src/pl/plpgsql/src/pl_handler.c
@@ -460,7 +460,7 @@ plpgsql_validator(PG_FUNCTION_ARGS)
 	tuple = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcoid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for function %u", funcoid);
-	proc = (Form_pg_proc) GETSTRUCT(tuple);
+	proc = GETSTRUCT(pg_proc, tuple);
 
 	functyptype = get_typtype(proc->prorettype);
 
diff --git a/src/pl/plpython/plpy_main.c b/src/pl/plpython/plpy_main.c
index 0bce106495..ab5fc74c1b 100644
--- a/src/pl/plpython/plpy_main.c
+++ b/src/pl/plpython/plpy_main.c
@@ -177,7 +177,7 @@ plpython3_validator(PG_FUNCTION_ARGS)
 	tuple = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcoid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for function %u", funcoid);
-	procStruct = (Form_pg_proc) GETSTRUCT(tuple);
+	procStruct = GETSTRUCT(pg_proc, tuple);
 
 	is_trigger = PLy_procedure_is_trigger(procStruct);
 
